/*
	SFXCtrlr.h
	
	Special Effects controller element
	
	Copyright 1994 by Al Evans. All rights reserved.
	
	6/8/94
	
*/

#ifndef SFXCTRLR
#define SFXCTRLR

#include "GraphElements.h"

typedef struct SFXController *SFXCtrlrPtr;

typedef pascal void (*SFXProcessor)(SFXCtrlrPtr controller);

typedef struct SFXController {
	GrafElement		baseGraphic;
	GWorldPtr		sfxSrc;				// copy of subject's graphic
	SFXProcessor	sfxProc;			// processor for this effect
	Ptr				sfxData;			// extra data for sfxProc
	long			firstStepTime;		// time first step will be executed
	short			currentStep;		// number of step now displayed
	short			nSteps;				// total number of steps
	Boolean			forward;			// true if stepping forward
	Boolean			sfxIn;				// true if graphic fading blank->graphic
} SFXController;

#ifdef __cplusplus
extern "C" {
#endif


//Make SFX controller and start effect
GrafElPtr DoGESFX(GEWorldPtr world, OSType ctrlrID, GrafElPtr subjectElement,
				SFXProcessor fxProc, short nSteps, short delay, short stepTime, 
				Boolean fxIn, Boolean forward);


//Autochange proc for SFX
pascal void AdvanceSFX(GEWorldPtr world, GrafElPtr graphic);

#ifdef __cplusplus
}
#endif


#endif