OSErr CallCompletion(short trapword, MPPPBPtr pb, long routine);
OSErr CallControl(short trapword, MPPPBPtr pb);

static void RestoreString(char* theString)
{
	NameLinkPtr pb = GetRegisteredNames();
	char* registeredName;
	short result;

	if (!pb) return;
	registeredName = pb->newString;

	while (true)
	{
		result = registeredName ? !PLstrcmp(theString, registeredName) : false;
		if (result)
		{
			PLstrcpy(theString, pb->newString);
			return;
		}
		pb = pb->next;
		if (!pb) break;
		registeredName = pb->newString;
	}
}

OSErr DoNewRemove(short trapword, MPPPBPtr pb)
{
	register OSErr error;
	register char *objName, *typeName;
	register Boolean async, objGood = false, typeGood = false;
	
	async = trapword & 0x0400;
	objName = ((char *)pb->NBPentityPtr);
	typeName = objName + objName[0] + 1;
	
	if (objName && objName[0])
	{
		if (StringIsMaskable(objName) && IsStringMasked(objName))
		{
			SetStringToMask(objName);
			objGood = true;
		}
		RemoveEntry(objName);
	}

	if (typeName && typeName[0])
	{
		if (StringIsMaskable(typeName) && IsStringMasked(typeName))
		{
			SetStringToMask(typeName);
			typeGood = true;
		}
		RemoveEntry(typeName);
	}
	
	error = CallControl(trapword, pb);
	
	if (objGood) RestoreString(objName);
	if (typeGood) RestoreString(typeName);
	
	return error;
}

OSErr DoNewRegister(short trapword, MPPPBPtr pb)
{
	register OSErr error;
	register char *objName, *typeName;
	register Boolean async, objGood = false, typeGood = false;
	
	async = trapword & 0x0400;
	objName = ((char *)pb->NBPentityPtr)+9;
	typeName = objName + objName[0] + 1;

	if (objName && objName[0] && StringIsMaskable(objName))				// should we worry about wiping the type?
	{
		if (!IsStringMasked(objName))
		{
			MaskString(objName);
			objGood = true;
		}
	}

	if (typeName && typeName[0] && StringIsMaskable(typeName))				// should we worry about wiping the type?
	{
		if (!IsStringMasked(typeName))
		{
			MaskString(typeName);
			typeGood = true;
		}
	}
	error = CallControl(trapword, pb);

	if (objGood) RestoreString(objName);
	if (typeGood) RestoreString(typeName);

	return error;
}

OSErr DoNewConfirm(short trapword, MPPPBPtr pb)
{
	register OSErr error;
	register char *objName, *typeName;
	register Boolean async, objGood = false, typeGood = false;
	
	async = trapword & 0x0400;
	objName = ((char *)pb->NBPentityPtr);
	typeName = objName + objName[0] + 1;
	
	if (objName && objName[0] && StringIsMaskable(objName))
	{
		Munge(objName);
		objGood = true;
	}

	if (typeName && typeName[0] && StringIsMaskable(typeName))
	{
		Munge(typeName);
		typeGood = true;
	}
	
	error = CallControl(trapword, pb);

	if (objGood) RestoreString(objName);
	if (typeGood) RestoreString(typeName);

	return error;
}
