/*
 *	Access to low-level Unix style functions
 */

#ifndef	_UNIX
#define	_UNIX

#ifndef _STDIO
#include <stdio.h>
#endif

/*
 * Mode values accessible to open()
 */

#define O_RDONLY		 0 		/* Bits 0 and 1 are used internally */
#define O_WRONLY		 1 		/* Values 0..2 are historical */
#define O_RDWR 			 2		/* NOTE: it goes 0, 1, 2, *!* 8, 16, 32, ... */
#define O_APPEND	(1<< 3)		/* append (writes guaranteed at the end) */
#define O_CREAT		(1<< 8)		/* Open with file create */
#define O_TRUNC		(1<< 9)		/* Open with truncation */
#define O_EXCL 		(1<<10) 	/* w/ O_CREAT:  Exclusive "create-only" */
#define O_BINARY	(1<<11) 	/* Open as a binary stream */

#ifdef __cplusplus
extern "C" {
#endif

int __open(const char *, int);
int __close(int);
int __read(int, unsigned char *, int);
int __write(int, const unsigned char *, int);
long __lseek(int, long,int);
int __unlink(const char *);
int _Fwrite(FILE *str, const unsigned char *, int);
int _Fread(FILE *str, unsigned char *, int);

#ifdef __cplusplus
}
#endif

#endif
