/**********************************************************************\

File:		program globals.h

Purpose:	This is the header file for all the program-specific
			global variables, #defines, enums, and structs.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#ifndef _PROGRAM_GLOBALS_H_
#define _PROGRAM_GLOBALS_H_

#define CREATOR			'2fx2'
#define APPLICATION_NAME "\pShutdown FX"
#define	SAVE_TYPE		'TEXT'
#define	USED_TYPE		'Fade'
#define UNUSED_TYPE		'Fad0'
#define MODULE_FOLDER	"\pMSG Fades"

enum					/* window indices in gTheWindowData[] lists */
{
	kAbout=0,			/* about box */
	kAboutMSG,			/* "About MSG" splash screen */
	kHelp,				/* help window */
	kMainWindow			/* main graphics window */
};

#define	NUM_WINDOWS		4		/* total number of windows (see above enum) */

enum ErrorTypes
{
	allsWell=0,
	
	/* shell errors */
	kNoMemory,
	kNoMemoryAndQuitting,
	kProgramIntegrityNotVerified,
	kProgramIntegritySet,
	kSystemTooOld,
	userCancelErr,
	
	/* deBinHex errors */
	kCantOpenInputFile,
	kCantCreateTempFile,
	kBinHexErr,
	kDiskReadErr,
	kDiskWriteErr,
	kNeedMoreBinHexErr,
	
	/* program-specific errors */
	kCantGetProc10Resource,
	kCantGetProc11Resource,
	kNoMemoryInSystemHeap,
	kCantMakeNewGestalt,
	kGestaltImproperlyInstalled,
	kCantFindSystemFolder,
	kCantFindModuleFolder,
	kNoModulesInFolder,
	kCantOpenModule,
	kModuleDamaged,
	kCantGetModuleInfo,
	kCantSetModuleInfo,
	kNoModulesInstalled
};

extern	short			gModuleIndex;
extern	char			gChooseRandom, gOnRestart, gOnShutdown;
extern	Str255			gModuleName;
extern	long			gModuleDirID;
extern	short			gModuleVRefNum;

#endif
